--------------------------BEGIN-VHDL-LICENCE-----------------------------
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
--------------------------BEGIN-VHDL-LICENCE-----------------------------
--
-- package : random_clear
-- created Wed Sep 12 03:18:00 2001 by whygee@f-cpu.org
--
-- This package is used as a replacement if you can't use
-- the normal package "random", for example if textio is not
-- implemented or something like that (and please, _only_ in
-- such cases). It's just for convenience/failsafe.
--
-------------------------------------------------------------------------------

LIBRARY ieee;
    USE ieee.std_logic_1164.ALL;
    
package random is

  function rand (var : std_ulogic_vector)  -- used to determine the size of the vector
    return std_ulogic_vector;

end random;

package body random is

  function rand (var : std_ulogic_vector)
    return std_ulogic_vector is
    variable t : std_ulogic_vector(var'range);
  begin
    t := (others => '0');
    return t;
  end;
  
end random;
